<?php

use EventPortal\Domain\Util\Toast\Toast;

if (function_exists('has_permission') === false) {
    function has_permission(string $permission): bool
    {
        $admin = optional(auth()->user())->admin;

        if ($admin === null) {
            return false;
        }

        try {
            return $admin->hasPermissionTo($permission);
        } catch (\Spatie\Permission\Exceptions\PermissionDoesNotExist $exception) {
            return false;
        }
    }
}

if (function_exists('toast') === false) {
    function toast(): Toast
    {
        return app('toast');
    }
}

if (function_exists('by_slug_or_id') === false) {
    /**
     * @param string|int $idOrSlug
     * @return mixed
     */
    function by_slug_or_id(string $model, $idOrSlug)
    {
        $modelBySlug = resolve($model)
            ->query()
            ->bySlug($idOrSlug)
            ->first();

        if ($modelBySlug) {
            return $modelBySlug;
        }

        return resolve($model)
            ->query()
            ->byId($idOrSlug)
            ->firstOrFail();
    }
}
